// Sound.h

#import <libc.h>
#import	<sound/sound.h>
#import <cthreads.h>
#import "Utilities.h"
#import "Parameters.h"

typedef struct _ThreadArgument {
	char 	hostname[256];
	int		portnumber;
	char	filename[1024];
	} ThreadArgument;


extern mutex_t	soundIsPlaying;
extern mutex_t	soundShouldStop;
extern int		soundShouldStopFlag;


// The function thread-forked to play sounds.
int PlaySound(ThreadArgument *theArgument);

