#import <appkit/View.h>

@interface Ruler : View
{
    id font;
    NXCoord descender;
    NXCoord startX;
    NXCoord lastlp, lasthp;
    BOOL flipped;
    BOOL notHidden;
}

+ (NXCoord)width;

- showPosition:(NXCoord)lp :(NXCoord)hp;
- hidePosition;

- setFont:aFont;
- setFlipped:(BOOL)flag;
- drawSelf:(const NXRect *)rects :(int)rectCount;

@end
