#import <objc/Object.h>


struct Point3D
{
	float x,y,z;
};

typedef struct Color
{
	float r,g,b;
} RGBcolor;

typedef struct Point3D point3D;
typedef struct Point3D vector3D; 


@interface FourSidedPolygon:Object

{
	point3D		vertex[4];
	vector		normal1, normal2;
	RGBcolor	topColor;
	RGBcolor	bottomColor;
	BOOL		viewingTop1, viewingTop2;
	BOOL		visible1,visible2; 
}

- init;
- drawSelf;
- calculateNormal;
@end
