
// This object handles all the nifty stuff in the Info> menu, like the various
// panels, the registration type of stuff, and the suggestions via mail.  It
// uses the same mail API as Opener, so it breaks under 3.0.  I'll fix it when
// I get 3.0.  Until then, tough luck...

#import <objc/Object.h>

#define unRegSerial "NREG"
#define versionString "1.2"

@interface InfoController:Object
{
    id	infoPanel;
    id	helpPanel;
    id	licensePanel;
    id	READMEPanel;
}

- init;					// make a new instance.
- infoPanel;			// return the infoPanel, or load it.
- helpPanel;			// return the helpPanel, or load it.
- licensePanel;			// return the licensePanel, or load it.
- readmePanel;			// return the readmePanel, or load it.
- info:sender;			// make the info panel be up there.
- help:sender;			// make the help panel be up there.
- license:sender;		// make the license panel be up there.
- readme:sender;		// make the readme panel be up there.
- suggestion:sender;	// This is pretty much lifted from Opener.

@end
