//

#import <appkit/appkit.h>
#import <objc/Object.h>
#import <sys/types.h>
#import <sys/stat.h>
#import "GopherClient.h"
#import "Parameters.h"
#import "Sound.h"

#define NIL 0

extern int shouldUseSound;

@interface GopherDispatcher:Object
{
id currentWindow;	// Watch out : this is not a window, but its delegate
id PrintMenuCell;
id SaveMenuCell;
id CloseMenuCell;
id GopherHostTextItem;
id GopherPortTextItem;
id PreferenceWindow;
id teminalApp;
id OpenHostTextItem;
id OpenPortTextItem;
id OpenWindow;
}

- newGopher:sender;
- openGopher:sender;
- closeGopher:sender;
- print:sender;
- save:sender;
- itemInfo:sender;
- stopSound:sender;
- findText:sender;

- newFrontWindow:sender;
- oldFrontWindow:sender;
- savePreferences:sender;

// Delegate methods

- appDidInit:sender;

@end
