/* This is RokNRoleApp.h */
/*  Copyright (c) 1992 - Rick A. Vander Kam - All rights reserved */

#import <appkit/Application.h>
#import <appkit/appkit.h>
#import <musickit/musickit.h>
#import <musickit/unitgenerators/unitgenerators.h>
#import <dsp/dsp.h>
#import <dsp/DSPConversion.h>

#import "FracdelayUGyyx.h"
#import "FracdelayUGxxy.h"
#import "Fir3UGyy.h"
#import "DcblockUGyy.h"
#import "Fir3UGxx.h"
#import "DcblockUGxx.h"
#import "CubicnlUGyy.h"

@interface RokNRoleApp:Application
{
    id	aButton;
    id	gButton;
    id	eButton;
    id	fir1a0f;
    id fir1a0s;
    id	dButton;
    id	fbgainf;
    id fbgains;
    id	x3f;
    id x3s;
    id	gsf;
    id gss;
    id	thrf;
    id thrs;
    id	fir1a1f;
    id fir1a1s;
    id	x2f;
    id x2s;
    id	fir2a0f;
    id fir2a0s;
    id	fbplf;
    id fbpls;
    id	xf;
    id xs;
    id	fir2a1f;
    id fir2a1s;
    id str1f;
    id str1s;
    id str2f;
    id str2s;
}

- appDidInit:sender;
- powerSwitch:sender;
- setFBGain:sender;
- pluck:sender;
- setPitch1:sender;
- setFIR2A1:sender;
- setFIR2A0:sender;
- setPitch2:sender;
- setFIR1A1:sender;
- setFIR1A0:sender;
- setDistoLevel:sender;
- setDistoCoeffX2:sender;
- setDistoThresh:sender;
- setFBPathLength:sender;
- setDistoCoeffX3:sender;
- setGlissSpeed:sender;
- setDistoCoeffX:sender;
- setPresetChord:sender;
- terminate:sender;

@end
