#import "Graphic.h"

@interface Image : Graphic
{
    id image;			/* an NXImage object */
    NXSize originalSize;	/* the original size */
    BOOL alphaOk, dontCache;
}

+ initialize;

/* Creation methods */

- initFromStream:(NXStream *)stream allowAlpha:(BOOL)alphaOk;
- free;

/* Overridden from superclass */

- (BOOL)isOpaque;
- (float)naturalAspectRatio;
- draw;
- setCacheable:(BOOL)flag;
- (BOOL)isCacheable;

/* Archiving methods */

- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

@end

