/* PGroup.h	by Paul Kunz	March 1991
 * Category extending the Group class
 *
 * Copyright (C)  1992  The Board of Trustees of
 * The Leland Stanford Junior University.  All Rights Reserved.
 */
 
#define PGROUP_H_ID "$Id: PGroup.h,v 1.7 1992/04/16 18:57:11 pfkeb Rel $"

#import "Group.h"

@interface Group(PGroup)

/* Each of the following methods performs the received message
 * to each member of the group
 */
- addCutPlot:cutPlot;
- addHTupleToList:list;
- addPlotToList:list;
- bindAxisW:(const void *) value;
- bindAxisX:(const void *) value;
- bindAxisXE:(const void *) value;
- bindAxisY:(const void *) value;
- bindAxisYE:(const void *) value;
- bindCuts;
- bindReference;
- NameAxisW:(const void *) value;
- NameAxisX:(const void *) value;
- NameAxisY:(const void *) value;
- NameAxisYE:(const void *) value;
- replace:oldTuple with:newTuple;
- replaceTupleWith:(const void *) value;
- setAutoScaleX:(const int *) value;
- setAutoScaleY:(const int *) value;
- setAxesFlag:(const void *) value;
- setColorType:(const void *) value;
- setDispType:(const void *) value;
- setDrawType:(const void *) value;
- setGraphicView:view;
- setLogScaleX:(const void *) value;
- setLogScaleY:(const void *) value;
- setNumBinsForAxisX:(const void *) value;
- setNumBinsForAxisY:(const void *) value;
- setRangeForAxisX:(const void *) value;
- setRangeForAxisY:(NXPoint *) value;
- setTitle:(const void *) value;
- setTitlesFlag:(const void *) value;
  
@end
