
/*
March 25, 1992

Handles everything dealing with the console, except its insistence at being the key window, which is handled by the file manager.

*/

#import <objc/Object.h>

@interface ConsoleManager:Object
{
    id	TheFileController;				// program objects.
    id  TheSoundManager;
    
    id	StopButton;						// interface objects.
    id	PlayButton;
    id	Meter;
    id	RecordButton;
    id  RecordFormButton;
	
    id  FortyMonoButton;
    id  FortyStereoButton;
    id  TwentyMonoButton;
    id  TwentyStereoButton;
    id  MuLawButton;
    id  TimedRecordButton;
    id  SecondsField;

}

- LeftSoundUp:sender;					// for changing volume...
- LeftSoundDown:sender;
- RightSoundUp:sender;
- RightSoundDown:sender;
- PlayDown:sender;
- RecordDown:sender;
- StopDown:sender;
- TurnOffPlay;							// sound finished
- TurnOffRecord;
- SetMeterTo:  ThisSound;

@end
