
/* InfoManager
	April 2
	
	The InfoManager handles the Information Window, which contains stuff like
	the sound type and sound length, file name, and whether or not the sound
	is fragmented.  The compact button on the information panel, however,
	goes to the edit controller for the time being. :(
	
 */

#import <objc/Object.h>

@interface InfoManager:Object
{
    id	Samples;							// samples field
    id	Fragmented;							// fragmented field
    id	Channels;							// channels field
    id	Seconds;							// etc.
    id	SoundType;
}

- NoWindow;									// No sound is currently open
- ChangeInfo:ThisSound;						// Sound is open, update info for
											// sound ThisSound.

@end
