/* 
 * PlotController.h -- Interface file for the PlotController class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use.
 *
 */

#import <objc/Object.h>
#import <dpsclient/event.h>

@interface PlotController:Object
{
	id	theScrollView;
	id	inputText;
	id	thePlotView;
	id	NukeCities;
}
- appDidInit:sender; 
- textDidGetKeys:theText isEmpty:(BOOL)flag;
- plotView:sender providePoints:(NXStream **)stream;
- NukeCities:sender;
- plotView:sender pointDidChange:(NXPoint *)aPoint;
- requestPlot:pasteboard userData:(const char *)userData error:(char **)msg;
@end
