/* File: Unknown.h - The 'Unknown' Application
 *
 * By: Christopher Lane
 * Symbolic Systems Resources Group
 * Knowledge Systems Laboratory
 * Stanford University
 *	
 * Contributor(s):
 *	
 *     Jiro Nakamura (jiro@heights.cit.cornell.edu)
 *
 * Date: 2 April 1991
 *
 * Copyright: 1989, 1990 & 1991 by The Leland Stanford Junior University.
 * This program may be distributed without restriction for non-commercial use.
 */
 
#import <appkit/Application.h>

@interface Unknown : Application { }

+ new;

- (BOOL) appAcceptsAnotherFile:sender;
- (int) appOpenFile:(const char *) filename type:(const char *) aType;
- appDidInit:sender;

- loadSegment:(const char *) segment section:(const char *) section;
- (int) ReOpenFile:(const char *) filename type:(const char *) aType;
- (BOOL) unix_error:(const char *) string;

@end
